<!DOCTYPE html>
<html>
	<head>
		<title>Linner Kodlar</title>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta http-equiv="X-UA-Compatible" content="IE=edge" />
		<meta name="viewport" content="width=device-width, initial-scale=1">
		<script type="text/javascript" src="jquery-1.10.2.js"></script>
		<script type="text/javascript" src="calculationlib/matrixlib.js"></script>
		<script type="text/javascript" src="calculationlib/ecclib.js"></script>
		<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.6/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>
		<!--<script type="text/javascript" src="MathJax/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>-->
		<script type="text/x-mathjax-config">
			MathJax.Hub.Config({tex2jax: {inlineMath: [['$','$'], ['\\(','\\)']]}});
			MathJax.Localization.setLocale("tr");
		</script>
		<script>
			var aggregate = function(arr, seed, func) {
				var accumulate = seed;
				for(var i = 0; i < arr.length; i++)
					accumulate = func(accumulate, arr[i]);
				return accumulate;
			}
			var AddFormula = function(container, name, tex) {
				var containerSelector = $('#' + container);
				if ($('#' + name).length == 0)
					containerSelector.append("<div id='" + name + "' style='text-align:center; visibility: visible; padding:10;'>");
				else $('#' + name).html("");

				$('#' + name).append($('<script type="math/tex">').text("\\displaystyle{"+tex+"}"));
				MathJax.Hub.Queue(["Typeset",MathJax.Hub]);
			}
			var ReadMatrix = function(text) {
				
				var data = [];
				text = text.replace( /\s\s+/g, ' ' );
				var lines = text.split(/\r|\n/);
				for (var i = 0; i < lines.length; i++) {
					var lineData = [];
					var cells = lines[i].split(' ');
					for (var j = 0; j < cells.length; j++) {
						if(cells[j] != "") {
							lineData.push(parseInt(cells[j]));
						}
					}
					if (lineData.length > 0)
						data.push(lineData);
				}
				return data;
			}
		</script>
	</head>

	<body>
		
		<table>
		<tr>
			<td> <label class="col-sm-2 control-label"><b>GF</b></label> </td> 
			<td> <input type="text" id="txtDegree" value="2"/> </td>
		</tr>
		<tr>
			<td> <label class="col-sm-2 control-label"><b>Üreteç <br />Matris</b></label> </td> 
			<td><!--<input type="text" id="txtGeneratorMatrix" value="[[1,1,1,1,1,1,1],[1,0,0,0,1,0,1],[1,1,0,0,0,1,0],[0,1,1,0,0,0,1]]"/>-->
			<textarea class="form-control" id="txtGeneratorMatrix" rows="5">
1 1 1 1 1 1 1
1 0 0 0 1 0 1
1 1 0 0 0 1 0
0 1 1 0 0 0 1</textarea>
			</td>
		</tr>
		<tr>
			<td> </td> 
			<td> <input type="button" id="btnWriteFormula" value="Matrisi Yaz" /> </td>
		</tr>
		</table>

		<div id="divResult"></div>
		
		
		
		<script type="text/javascript">
			$(document).ready(function () {
				$("input[type='button']").click(function (e) {
					if (e.target.id == "btnWriteFormula") {

						var q = parseInt($('#txtDegree').val());
						//var arr= eval($('#txtGeneratorMatrix').val());
						var text = $('#txtGeneratorMatrix').val();
						var arr = ReadMatrix(text);
						var mat = new Matrix(arr);
						var processor = new MatrixCalculator(q);
						var matGen = new MatrixGenerator(q);
						var code = new ErrorCorrectingCode(mat, q);

						$("#divResult").html("");
						var info = "\\begin{eqnarray*}";
						info += "q&=&" + code.q + " \\\\";
						info += "n&=&" + code.n + " \\\\";
						info += "k&=&" + code.k + " \\\\";
						info += "M&=&" + code.M + " \\\\";
						info += "d&=&" + code.d + " \\\\";
						info += "t&=&" + code.t;
						info += "\\end{eqnarray*}";
						AddFormula("divResult", "MathOutputInfo", info);
						$("#divResult").append("<br />");
						
						
						var generator_text = "G=" + code.Generator.ToLatex(true);
						AddFormula("divResult", "MathOutputGenerator", generator_text);
						$("#divResult").append("<br />");
						
						
						var parity_check_text = "H=" + code.DualCode().Generator.ToLatex(true);
						AddFormula("divResult", "MathOutputParityCheckSF", parity_check_text);
						$("#divResult").append("<br />");
						
						
						var parity_check_text = "GH^T=" + processor.Multiply(code.Generator, code.DualCode().Generator.Transpose()).ToLatex(true);
						AddFormula("divResult", "MathOutputParityCheckKontrol", parity_check_text);
						$("#divResult").append("<br />");
						
						if (code.M < 100) {
							// Codewords begin
							var codeWordsText = "\\begin{array}{c|cc} word & codeword & weight \\\\ \\hline";
							for (var i = 0; i < code.M; i++) {

								var word = code.GetWord(i)
								var sfw = code.CalculateCodeword(word);

								var word_orj = word.Text;
								var word_cod = sfw.Text;
								var word_weight = "w=" + sfw.weight;
								//var word_csf = sfw.Text;
								//codeWordsText +=  + "\\rightarrow" +  + " | " + ;
								codeWordsText += word_orj + "&" + word_cod + "&" + word_weight;
								if(i != code.M-1)
									codeWordsText += "\\\\";
							}
							codeWordsText += "\\end{array}";
							AddFormula("divResult", "MathOutputCodewords", codeWordsText);
							// Codewords end
						}
						
						return;
						// Cosets begin
						var syndromeCount = Math.pow(code.q, code.n-code.k);
						var syndromeWords = code.FindWords(code.q, code.n-code.k);
						var allWords = code.FindWords(code.q, code.n);
						var syndromeCodes = [];
						for (var i = 0; i < syndromeCount; i++)
							syndromeCodes[syndromeWords[i].Text] = [];

						for (var i = 0; i < allWords.length; i++) {
							var word = allWords[i];
							var syd = new CodeWord(processor.Multiply(word.Data, code.PartiyCheckSF.Transpose()));
							syndromeCodes[syd.Text].push(word);
						}

						var maxWordCount = 0;
						var syndromeCosetText = "";
						for (var i = 0; i < syndromeCount; i++) {
							var syd = syndromeWords[i];
							var words = syndromeCodes[syd.Text];
							var maxWordCount = Math.max(maxWordCount, words.length);

							for (var j = 1; j < words.length; j++) {
								if (words[0].weight > words[j].weight) {
									var tmp = words[0];
									words[0] = words[j];
									words[j] = tmp;
								}
							}

							line = syd.Text + "&";
							for (var j = 0; j < words.length; j++) {
								line += words[j].Text;
								if (j != words.length - 1)
									line += "&";
							}
							if(i != syndromeCount-1)
								line += "\\\\";
							syndromeCosetText += line;
						}

						syndromeCosetText = "\\begin{array}{c|c|"+ 'c'.repeat(maxWordCount-1) + "} Syndrome & Coset \\ leader " + '& '.repeat(maxWordCount-1) + "\\\\ \\hline " + syndromeCosetText;
						syndromeCosetText += "\\end{array}";
						WriteFormula("MathOutputCosets", syndromeCosetText);
						// Cosets end
						
						
						
						// weight counter begin
						var weights = [];
						for (var i = 0; i <= code.n; i++)
							weights[i] = 0;
						for (var i = 0; i < code.M; i++)
							weights[code.CodeWords[i].weight] += 1;
						var weightCounterText = "";
						for (var i = 0; i <= code.n; i++){
							if (weights[i] == 0)
								continue;
							weightCounterText += weights[i];
							if(code.n-i != 0)
								weightCounterText += "x^"+(code.n-i);
							if(i != 0)
								weightCounterText += "y^" + i;
							weightCounterText += "+";
						}
						if(weightCounterText.length > 0)
							weightCounterText = weightCounterText.substring(0,weightCounterText.length-1);
						// weight counter end

						WriteFormula("MathOutputWeightCounter", "W_C=" + weightCounterText)
					}
				});
			});
		</script>

	</body>
</html>
